<?php //$Id: block_course_ascendants.php,v 1.1.2.2 2012/02/26 14:14:57 diml Exp $

class block_course_ascendants extends block_list {
    function init() {
        $this->title = get_string('title', 'block_course_ascendants') ;
        $this->version = 2012022000;
    }

    function has_config() {
        return false;
    }

    function applicable_formats() {
        return array('site' => false, 'course' => true);
    }

    function get_content() {
        global $THEME, $CFG, $COURSE;

        if ($this->content !== NULL) {
            return $this->content;
        }
        
        if (!isset($this->config->showcategories)){
        	$this->config->showcategories = false;
        }
        
        $coursecontext = get_context_instance(CONTEXT_COURSE, $COURSE->id);

        // fetch direct ascendants that are metas who point the current course as descendant

        $sql = "
             SELECT DISTINCT 
                c.id,
                c.shortname,
                c.fullname,
                c.sortorder,
                c.visible,
                cc.name as catname,
                cc.id as catid,
                cc.visible as catvisible
             FROM 
                 {$CFG->prefix}course c,
                 {$CFG->prefix}course_categories cc,
                 {$CFG->prefix}course_meta mc
             WHERE
                c.id = mc.parent_course AND
                c.category = cc.id AND
                mc.child_course = {$COURSE->id}
             ORDER BY
                 cc.sortorder,
                 c.sortorder
        ";

        $ascendants = get_records_sql($sql);

        $this->content = new stdClass;
        $this->content->items = array();
        $this->content->icons = array();
        $this->content->footer = '';
        
        if ($ascendants) {
        	$prevcat = '';
            foreach ($ascendants as $ascendant) {
            	
            	if ($ascendant->catname != $prevcat){
            		$prevcat = $ascendant->catname;
            		if ($this->config->showcategories){
            			$this->content->items[] = "<b>$prevcat</b>";
            		}
            	}

                // TODO : check visibility on upper categories
                $catcontext = get_context_instance(CONTEXT_COURSECAT, $ascendant->catid);
                if ($ascendant->catvisible || has_capability('moodle/category:viewhiddencategories', $catcontext)){
                
	                $context = get_context_instance(CONTEXT_COURSE, $ascendant->id);
	                if ($ascendant->visible || has_capability('moodle/course:viewhiddencourses', $context)){
	
	                    $icon  = '';
	                    $this->content->icons[] = $icon;
	                    
	                    $fullname = shorten_text($ascendant->fullname, 35);
	    
	                    $this->content->items[] = "<a title=\"" .s($ascendant->fullname).
	                        "\" href=\"{$CFG->wwwroot}/course/view.php?id={$ascendant->id}\">{$fullname}</a>";
	                }
	            }
            }
        }
        
        if (has_capability('moodle/course:manageactivities', $coursecontext)){
        	$manageascendantsstr = get_string('manageascendants', 'block_course_ascendants');
        	$this->content->footer = "<a href=\"{$CFG->wwwroot}/blocks/course_ascendants/assign.php?course={$COURSE->id}&amp;id={$this->instance->id}&amp;sesskey=".sesskey()."\">$manageascendantsstr</a>";
        }

        return $this->content;
    }

    /**
    *
    */
    function user_can_addto($page) {
        global $CFG, $COURSE;

        $context = get_context_instance(CONTEXT_COURSE, $COURSE->id);
        if (has_capability('block/course_ascendants:canaddto', $context)){
        	return true;
        }
        return false;
    }

    /**
    *
    */
    function user_can_edit() {
        global $CFG, $COURSE;

        $context = get_context_instance(CONTEXT_COURSE, $COURSE->id);
        
        if (has_capability('block/course_ascendants:configure', $context)){
 	       return true;
        }

		return false;
    }
}

?>
